//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "WMFCanvasWorkAround.hpp"
//---------------------------------------------------------------------------
#pragma link "RichView"
#pragma link "RVScroll"
#pragma link "RVStyle"
#pragma link "RVReport"
#pragma link "PtblRV"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  // generating a document
  for (int i = 1; i<=3; i++)
  {
    rv->AddNL("Chapter "+IntToStr(i), 1, 1);
    if (rv->ItemCount > 1)
      rv->PageBreaksBeforeItems[rv->ItemCount-1] = true;
    for (int j = 0; j<20; j++)
      rv->AddNL("This is a line of text",0,0);
  }
  rv->Format();
  // initializing ReportHelper
  rvHelper->RichView->Style = RVStyle2;
  rvHelper->RichView->Color = rv->Color;
  rvHelper->RichView->LeftMargin   = rv->LeftMargin;
  rvHelper->RichView->TopMargin    = rv->TopMargin;
  rvHelper->RichView->RightMargin  = rv->RightMargin;
  rvHelper->RichView->BottomMargin = rv->BottomMargin;
  // copying the document to ReportHelper
  TMemoryStream* Stream = new TMemoryStream;
  rv->SaveRVFToStream(Stream, false);
  Stream->Position = 0;
  rvHelper->RichView->LoadRVFFromStream(Stream);
  delete Stream;
  // reformat and display
  FormatReportHelper();
}
//---------------------------------------------------------------------------
int GetEditValue(TEdit* Edit)
{
  int r = StrToIntDef(Edit->Text, 100);
  if (r<20)
    r = 20;
  Edit->Text = IntToStr(r);
  return r;
}
//---------------------------------------------------------------------------
void TForm1::FormatReportHelper()
{
  rvHelper->IgnorePageBreaks = cbIgnorePageBreaks->Checked;
  int Width = GetEditValue(txtWidth);
  int Height = GetEditValue(txtHeight);
  rvHelper->Init(this->Canvas, Width);
  while (rvHelper->FormatNextPage(Height)) ;
  btnRecreate->Enabled = false;
  sbPage->Enabled = true;
  sbPage->Max = rvHelper->PagesCount;
  DisplayPage();
}
//---------------------------------------------------------------------------
TMetafile* TForm1::GetPageMetafile(int PageNo, int Width, int Height)
{
  TMetafile * wmf = new TMetafile;
  wmf->Width = Width;
  wmf->Height = Height;
  TMetafileCanvas* Canvas = (TMetafileCanvas*)CreateMetafileCanvas(wmf);
  rvHelper->DrawPage(PageNo, Canvas, true, Height);
  delete Canvas;
  return wmf;
}
//---------------------------------------------------------------------------
Graphics::TBitmap* TForm1::GetPageBitmap(int PageNo, int Width, int Height)
{
  Graphics::TBitmap* bmp = new Graphics::TBitmap;
  bmp->Width = Width;
  bmp->Height = Height;
  rvHelper->DrawPage(PageNo, bmp->Canvas, true, Height);
  return bmp;
}
//---------------------------------------------------------------------------
void TForm1::DisplayPage()
{
  int PageNo = sbPage->Position;
  rvHelper->TransparentBackground = cbTransparent->Checked;
  int Width = GetEditValue(txtWidth);
  int Height;
  if (cbAutoHeight->Checked && PageNo==rvHelper->PagesCount)
    Height = rvHelper->GetLastPageHeight();
  else
    Height = GetEditValue(txtHeight);
  TGraphic* Gr = NULL;
  switch (rgFormat->ItemIndex)
  {
    case 0:
      Gr = GetPageBitmap(PageNo, Width, Height);
      break;
    case 1:
      Gr = GetPageMetafile(PageNo, Width, Height);
      break;
  }
  Img->Picture->Graphic = Gr;
  delete Gr;
  lblPage->Caption = "Page "+IntToStr(PageNo)+" of "+IntToStr(rvHelper->PagesCount);
  lblPage->Visible = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::txtWidthOrHeightChange(TObject *Sender)
{
  btnRecreate->Enabled = true;
  sbPage->Enabled = false;
  lblPage->Visible = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::sbPageChange(TObject *Sender)
{
  DisplayPage();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnRecreateClick(TObject *Sender)
{
  FormatReportHelper();        
}
//---------------------------------------------------------------------------

