//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "StyleListFrm.h"
#include "StyleFrm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "RVStyle"
#pragma resource "*.dfm"
TfrmStyleList *frmStyleList;
//---------------------------------------------------------------------------
__fastcall TfrmStyleList::TfrmStyleList(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
// Updating buttons when selection is changed
void __fastcall TfrmStyleList::lstClick(TObject *Sender)
{
  btnEdit->Enabled = lst->ItemIndex>=0;
  btnDelete->Enabled = lst->ItemIndex>=0 && lst->Items->Strings[lst->ItemIndex]!="Normal";
}
//---------------------------------------------------------------------------
void __fastcall TfrmStyleList::FormActivate(TObject *Sender)
{
  lstClick(Sender);
}
//---------------------------------------------------------------------------
void TfrmStyleList::UpdateList()
{
  TRVStyleTemplateKinds Kinds = TRVStyleTemplateKinds();
  Kinds << rvstkText;
  Kinds << rvstkPara;
  Kinds << rvstkParaText;
  rvs->StyleTemplates->AssignToStrings(lst->Items, true,
    Kinds, NULL, false);
}
//---------------------------------------------------------------------------
// Adding a new style template
void __fastcall TfrmStyleList::btnAddClick(TObject *Sender)
{
  rvs->StyleTemplates->ResetNameCounter();
  rvs->StyleTemplates->Add();
  UpdateList();
  lst->ItemIndex = lst->Items->Count-1;
  lstClick(Sender);
}
//---------------------------------------------------------------------------
// Deleting the selected style template
void __fastcall TfrmStyleList::btnDeleteClick(TObject *Sender)
{
  int idx = lst->ItemIndex;
  rvs->StyleTemplates->ForbiddenIds->Add(rvs->StyleTemplates->Items[idx]->Id);
  delete rvs->StyleTemplates->Items[idx];
  if (idx==lst->Items->Count-1)
    idx--;
  UpdateList();
  lst->ItemIndex = idx;
  lstClick(Sender);
}
//---------------------------------------------------------------------------
// Editing the selected style template
void __fastcall TfrmStyleList::btnEditClick(TObject *Sender)
{
  TfrmStyle* frm = new TfrmStyle(Application);
  frm->rvs->StyleTemplates->AssignStyleTemplates(rvs->StyleTemplates, true);
  frm->Index = lst->ItemIndex;
  frm->DisplayStyleTemplate();
  if (frm->ShowModal()==mrOk)
  {
    rvs->StyleTemplates->Items[lst->ItemIndex]->Assign(
      frm->rvs->StyleTemplates->Items[frm->Index]);
    // The line above does not assign NextId and ParentId, because the source
    // and the target style templates belong to different collections
    rvs->StyleTemplates->Items[lst->ItemIndex]->NextId =
      frm->rvs->StyleTemplates->Items[frm->Index]->NextId;
    rvs->StyleTemplates->Items[lst->ItemIndex]->ParentId =
      frm->rvs->StyleTemplates->Items[frm->Index]->ParentId;
    lst->Items->Strings[lst->ItemIndex] = rvs->StyleTemplates->Items[lst->ItemIndex]->Name;
  }
  delete frm;
}
//---------------------------------------------------------------------------
