{==============================================================================}
{
  Mail merge application: part 1 - template editor
  (Fire DAC + Interbase version)
  Editing template and data for fields.

  Template: RVStyle for template (RVStyle2) has two text styles
  (0-th for normal text, 1 - for fields (with special Protection options)
  Other styles can be added dynamically (right-click editor in Delphi,
  "Settings" in the context menu).
  Template is stored in Template.rvf.

  Data for fields: stored in FIELDS.GDB|FIELDSTABLE
  There are two db-fields in this table:
  - ID - string, field code
  - VALUE - rvf, field value
  Styles can be added dynamically in Data editor.
}
{==============================================================================}
unit TEFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, DB, RVScroll, RichView, RVEdit, DBRV, ComCtrls,
  StdCtrls, Mask, DBCtrls, RVStyle, ExtCtrls, FireDAC.Stan.Intf,
  FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf,
  FireDAC.Stan.Def, FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys,
  FireDAC.Phys.IB, FireDAC.Stan.Param, FireDAC.DatS, FireDAC.DApt.Intf,
  FireDAC.DApt, FireDAC.Comp.DataSet, FireDAC.Comp.Client;

type
  TfrmTE = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    DBRichViewEdit1: TDBRichViewEdit;
    DataSource1: TDataSource;
    DBNavigator1: TDBNavigator;
    RVStyle1: TRVStyle;
    DBEdit1: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    RVStyle2: TRVStyle;
    RichViewEdit1: TRichViewEdit;
    Button1: TButton;
    Label3: TLabel;
    FDConnection1: TFDConnection;
    FDTable1: TFDTable;
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmTE: TfrmTE;

implementation

{$R *.dfm}

procedure TfrmTE.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  if FDTable1.State=dsInsert then
    Label2.Caption := '(new)'
  else if FDTable1.RecordCount=0 then
    Label2.Caption := '(empty)'
  else
    Label2.Caption := Format('Record %d of %d', [FDTable1.RecNo, FDTable1.RecordCount]);
end;

procedure TfrmTE.FormCreate(Sender: TObject);
begin
  with FDConnection1.Params do begin
    Clear;
    Add('DriverID=IB');
    Add('Database='+ExtractFilePath(Application.ExeName)+'Fields.gdb');
    Add('User_Name=SYSDBA');
    Add('Password=masterkey');
  end;
  FDConnection1.Connected := True;
  FDTable1.Open('FieldsTable');

  RichViewEdit1.Clear;
  RichViewEdit1.LoadRVF(ExtractFilePath(Application.ExeName)+'template.rvf');
  RichViewEdit1.Format;
end;

procedure TfrmTE.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if FDTable1.State in [dsEdit, dsInsert] then
    FDTable1.Post;
  RichViewEdit1.SaveRVF(ExtractFilePath(Application.ExeName)+'template.rvf', False);
end;

procedure TfrmTE.Button1Click(Sender: TObject);
var s: String;
begin
  s := '';
  if InputQuery('Insert Field', 'Field code:', s) then begin
    if s='' then
      exit;
    // s must be equal to one of Codes in the database
    RichViewEdit1.SetFocus;
    RichViewEdit1.CurTextStyleNo := 1;
    RichViewEdit1.InsertText(s, False);
  end;
end;

end.
