{==============================================================================}
{ DB Demo 1: using TRichViewEdit to edit RVF field                             }
{ This demo uses FireDAC and Interbase tables.                                 }
{=============================} unit Unit1; {==================================}
{ Main properties were set at design time:                                     }
{ DataSource1.Dataset        := FDTable1;                                      }
{ FDTable1.Dataset           := FDConnection1;                                      }
{ DBNavigator1.DataSource    := DataSource1;                                   }
{ DBEdit1.DataSource         := DataSource1;                                   }
{ DBRichView1.DataSource     := DataSource1;                                   }
{ DBRichView1.Style          := RVStyle1;                                      }
{ DBEdit1.DataField          := 'CAPTION';  // Alphanumeric field              }
{ DBRichViewEdit1.DataField  := 'DOCUMENT'; // Binary field                    }
{ nbEdit was removed from DBNavigator1.VisibleButtons (because of autoedit)    }
{------------------------------------------------------------------------------}
{ Note: changes after last posting are not saved when exiting application.     }
{==============================================================================}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBCtrls, RVScroll, RichView, RVEdit, DBRV, RVStyle, DB,
  StdCtrls, Mask, Buttons, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf, FireDAC.Stan.Def,
  FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys, FireDAC.Stan.Param,
  FireDAC.DatS, FireDAC.DApt.Intf, FireDAC.DApt, FireDAC.Comp.DataSet,
  FireDAC.Comp.Client, FireDAC.Phys.IB, FireDAC.Phys.IBDef;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    RVStyle1: TRVStyle;
    DBNavigator1: TDBNavigator;
    Label1: TLabel;
    Label2: TLabel;
    DBEdit1: TDBEdit;
    Label3: TLabel;
    DBRichView1: TDBRichView;
    Button1: TButton;
    FDConnection1: TFDConnection;
    FDTable1: TFDTable;
    procedure FormCreate(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateStatusLabel;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses Unit2;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  with FDConnection1.Params do begin
    Clear;
    Add('DriverID=IB');
    Add('Database='+ExtractFilePath(Application.ExeName)+'SampleTable.gdb');
    Add('User_Name=SYSDBA');
    Add('Password=masterkey');
  end;
  FDConnection1.Connected := True;
  FDTable1.Open('');

  RVStyle1.TextStyles[1] := RVStyle1.TextStyles[0];
  RVStyle1.TextStyles[1].Style := RVStyle1.TextStyles[1].Style+[fsBold];
end;

procedure TForm1.UpdateStatusLabel;
begin
  // where we are
  if FDTable1.State=dsInsert then
    Label3.Caption := '(new)'
  else if FDTable1.RecordCount=0 then
    Label3.Caption := '(empty)'
  else
    Label3.Caption := Format('Record %d of %d', [FDTable1.RecNo, FDTable1.RecordCount]);
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  UpdateStatusLabel;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  // See Unit2.pas
  Form2.SetField('DOCUMENT',FDTable1);
  Form2.ShowModal;
end;

end.
