unit StyleListFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, RVStyle;

type
  TfrmStyleList = class(TForm)
    lst: TListBox;
    btnAdd: TButton;
    btnEdit: TButton;
    btnDelete: TButton;
    Button1: TButton;
    Button2: TButton;
    rvs: TRVStyle;
    procedure lstClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnEditClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation
uses StyleFrm;

{$R *.DFM}
{------------------------------------------------------------------------------}
// Updating buttons when selection is changed
procedure TfrmStyleList.lstClick(Sender: TObject);
begin
  btnEdit.Enabled := lst.ItemIndex>=0;
  btnDelete.Enabled := (lst.ItemIndex>=0) and (lst.Items[lst.ItemIndex]<>'Normal');
end;

procedure TfrmStyleList.FormActivate(Sender: TObject);
begin
  lstClick(Sender);
end;
{------------------------------------------------------------------------------}
// Adding a new style template
procedure TfrmStyleList.btnAddClick(Sender: TObject);
begin
  rvs.StyleTemplates.ResetNameCounter;
  rvs.StyleTemplates.Add;
  rvs.StyleTemplates.AssignToStrings(lst.Items, True,
    [rvstkText, rvstkPara, rvstkParaText], nil, False);
  lst.ItemIndex := lst.Items.Count-1;
  lstClick(Sender);
end;
{------------------------------------------------------------------------------}
// Deleting the selected style template
procedure TfrmStyleList.btnDeleteClick(Sender: TObject);
var idx: Integer;
begin
  idx := lst.ItemIndex;
  rvs.StyleTemplates.ForbiddenIds.Add(rvs.StyleTemplates[idx].Id);
  rvs.StyleTemplates[idx].Free;
  if idx=lst.Items.Count-1 then
    dec(idx);
  rvs.StyleTemplates.AssignToStrings(lst.Items, True,
    [rvstkText, rvstkPara, rvstkParaText], nil, False);
  lst.ItemIndex := idx;
  lstClick(Sender);
end;
{------------------------------------------------------------------------------}
// Editing the selected style template
procedure TfrmStyleList.btnEditClick(Sender: TObject);
var frm: TfrmStyle;
begin
  frm := TfrmStyle.Create(Application);
  frm.rvs.StyleTemplates.AssignStyleTemplates(rvs.StyleTemplates, True);
  frm.Index := lst.ItemIndex;
  frm.DisplayStyleTemplate;
  if frm.ShowModal=mrOk then begin
    rvs.StyleTemplates[lst.ItemIndex] := frm.rvs.StyleTemplates[frm.Index];
    // The line above does not assign NextId and ParentId, because the source
    // and the target style templates belong to different collections
    rvs.StyleTemplates[lst.ItemIndex].NextId := frm.rvs.StyleTemplates[frm.Index].NextId;
    rvs.StyleTemplates[lst.ItemIndex].ParentId := frm.rvs.StyleTemplates[frm.Index].ParentId;    
    lst.Items[lst.ItemIndex] := rvs.StyleTemplates[lst.ItemIndex].Name;
  end;
  frm.Free;
end;

end.
